=== debian/changelog ===
maildir-utils (1.12.14-1) unstable; urgency=medium

  * New upstream version 1.12.13
    - mu4e
      + add `mu4e-quit-hook`, a hook is just before quitting mu4e. See its
        docstring for details.
      + add `mu4e-dbus-mode`, an experimental minor mode which, if enabled on an
        Emacs with DBus-support, exposes some of Mu4e's state (such as the
        read/unread counts of bookmarked queries) on the DBus session bus.  See
        the mu4e manual for further details.
    - scm
      + some methods that returned lists would return `#f` when there were no
        results (e.g., `to`, `from`, `cc`, `bcc`, `references`, `labels`);
        however, it's nicer to return an empty list instead, which is what is
        now done.
      + new convenience methods `root-maildir` and `personal-addresses` for
        store objects. See the reference manual for details.
  * d/control
    - bump Standards-Version to 4.7.3
  * d/patches
    -  refresh patches
  * d/p/man-page-fixes.patch
    - add patch to fix errors in mu-labels.1 and mu-scm.1

 -- Jeremy Sowden <azazel@debian.org>  Thu, 01 Jan 2026 16:53:22 +0000
